#!/usr/bin/perl
####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: category.cgi
#  Description: add modify delete categories
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################
$0 =~ /^(.*)[\/\\].*/ && chdir ($1) ; $|=1;
use strict;
use CGI();
use CGI::Carp('fatalsToBrowser');
use DBI;
use lib './modules';
use GLOBAL;
use CONFIG;
my $in = new CGI;
   print $in->header();
my $data;
my $user = &GLOBAL::user;
   $data->{id} = $in->param('id');
   $data->{action} = $in->param('action');
   $data->{father} = $in->param('father') || undef;
   $data->{name} = $in->param('name') || undef;
   if ($data->{action} eq "delete") {
         $data->{id} = $in->param('id') || &GLOBAL::error('noid');
      my $record = &GLOBAL::get_record($data->{id},$CONFIG::category_table);
         if (!$record->{id}) {&GLOBAL::error('noid');}
         else {
           &GLOBAL::delete_record('id',$data->{id},$CONFIG::category_table);
           &GLOBAL::template('category_deleted',$data,'navigation_category');
         }
   }
   elsif ($data->{action} eq "add") {
      if ($data->{name} && $data->{father}) {
            if ( $data->{name} =~ /[\W]/) {&GLOBAL::error('noirreg');}
         my $fatherdata = &GLOBAL::get_record($data->{father},$CONFIG::category_table);
            $data->{name} = $fatherdata->{name} . "/" . $data->{name};
         my $results = &GLOBAL::add_data($data,$CONFIG::category_table);
            $data->{used_id} = $results->{used_id};
            $data->{table_name} = $results->{table_name};
            $data->{table_results} = $results->{table_results};
            &GLOBAL::template('category_added',$data,'navigation_category');
      }
      else {
         $data->{father} = &GLOBAL::get_cat;
         &GLOBAL::template('category_add_form',$data,'navigation_category');
      }
   }
   elsif ($data->{action} eq 'modify' && $data->{id}) {
         if ( $data->{name} =~ /[\W]/) {&GLOBAL::error('noirreg');}
      my $fatherdata = &GLOBAL::get_record($data->{father},$CONFIG::category_table);
         $data->{name} = $fatherdata->{name} . "/" . $data->{name};
      my $results = &GLOBAL::modify_data($data,$CONFIG::category_table);
         $data->{table_name} = $results->{table_name};
         $data->{table_results} = $results->{table_results};
         &GLOBAL::template('category_modified',$data,'navigation_category');
   }
   elsif ($data->{action} eq 'modify_form' && $data->{id}) {
      my $data = &GLOBAL::get_record($data->{id},$CONFIG::category_table);
         $data->{father_drop} = &GLOBAL::get_cat($data->{id});
         $data->{name} =~ /(.*)\/(.*)/;
         $data->{name_father} = $1;
         $data->{name} = $2;
         &GLOBAL::template('category_modify_form',$data,'navigation_category');
   }
   else {
      my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
      my $sth = $dbh->prepare (qq~SELECT * FROM $CONFIG::category_table ORDER BY name~);
         $sth->execute ();
         $data->{count} = $sth->rows;
         if ($data->{count} > 0) {
            while (my @ary = $sth->fetchrow_array ()) {
               if ($ary[0] eq 1) {next;}
               $data->{results} .= qq~
                  <tr>
                     <td>$ary[0]</td>
                     <td>$ary[1]</td>
                     <td>$ary[2]</td>
                     <td><nobr><a href=category.cgi?id=$ary[0]&action=modify_form>$CONFIG::variables->{cmd_modify}</a>
                        &nbsp;<a href=category.cgi?id=$ary[0]&action=delete onClick="return confirm('Delete the record?')">$CONFIG::variables->{cmd_delete}</a>
                    </nobr></td>
                  </tr>~;
            }
         }
         else {
            $data->{results} = qq~<tr><td colspan=4>$CONFIG::variables->{noresults}</td></tr>~;
            $data->{count} = qq~ 0 ~;
         }
         $sth->finish ();
         $dbh->disconnect ();
         &GLOBAL::template('category_list_results',$data,'navigation_category');
   }
exit;