####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: CONFIG.pm
#  Description: Configurations and settings for prosupporter
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################

package CONFIG;

####################################################################
# you must change variables signed like that: ##VARIABLE##
####################################################################

# access data for the database
$dsn            = "DBI:mysql:##DATABASENAME##:##HOST##";
$username       = "##USERNAME##";
$password       = "##PASSWORD##";

# access for pop3-account
$pop_user = '##username##';
$pop_pass = '##password##';
$pop_host = '##pop3.server.com##';
$pop_size = 100000;

# names for the support tables
$default_table  = "ams_default";
$category_table = "ams_cat";
$staff_table    = "ams_user";
$list_table     = "ams_list";

################################################################
# output variables which can be modified
################################################################
$variables->{url}            = '##http://www.yourdomain.com/with/path/to/support##';
$variables->{adminmail}      = '##email@yourdomain.com##';
$variables->{recordsppage}   = 25;
$variables->{'title'}        = 'prosupporter';
$variables->{'listbgcolor1'} = 'ffffff';
$variables->{'listbgcolor2'} = 'c0c0c0';
$variables->{'css'}          = qq~
.Titel {color:#ffffff;font-weight: bold;font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px;background: #29518C;}
a.Menue, a.Menue:visited {color:black;background-color:#c0c0c0;padding:3px;border:1px solid #c0c0c0;text-decoration: none;}
a.Menue:hover {color:black;background-color:#c0c0c0;padding:3px;border-bottom:1px solid #666666;border-left:1px solid #ffffff;border-top:1px solid #ffffff;border-right:1px solid #666666;text-decoration:none;}
a.Copy, a.Copy:visited {color:#c0c0c0;background: transparent; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; text-decoration: none;}
a, a:visited {color:#29518C;background: transparent; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; text-decoration: none;}
a:hover, a:active {background: transparent; color: #000000; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; text-decoration: underline;}
font,p,td,pre {font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 11px;}
h1,h2 {color: #000000; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px; font-weight:bold;}
table {background: silver;}
td {background : #ffffff;}
td.navi {background : #c0c0c0;}
input,textarea,select { background-color:fdfdfd; color:#000000; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; border:1px solid #003366;}
#menu {width:130px; text-align:left;}
#menu a {text-decoration:none; background-color:#c0c0c0; color:#000000; display:block; width:120px; height:16px; font-size:12px; border-right:5px solid #ffffff; margin:5px;}
#menu a:hover {text-decoration:none; background-color:#c0c0c0; color:#29518C; display:block; width:120px; height:16px; font-size:12px; border-right:5px solid #29518C; margin:5px;}
~;

$month->{1}  = "January";
$month->{2}  = "February";
$month->{3}  = "March";
$month->{4}  = "April";
$month->{5}  = "Mai";
$month->{6}  = "June";
$month->{7}  = "July";
$month->{8}  = "August";
$month->{9}  = "September";
$month->{10} = "Oktober";
$month->{11} = "November";
$month->{12} = "Dezember";

$day->{1} = "Su";
$day->{2} = "Mo";
$day->{3} = "Tu";
$day->{4} = "We";
$day->{5} = "Th";
$day->{6} = "Fr";
$day->{7} = "Sa";


# command buttons and links
$variables->{cmd_add}        = 'add';
$variables->{cmd_search}     = 'search';
$variables->{cmd_modify}     = 'modify';
$variables->{cmd_whole}      = 'whole';
$variables->{cmd_delete}     = 'delete';
$variables->{cmd_forward}    = 'forward';
$variables->{cmd_send}       = 'send';
$variables->{cmd_mail}       = 'mail';
$variables->{cmd_misc}       = 'misc';
$variables->{cmd_fwd}        = 'fwd';
$variables->{cmd_junk}       = 'junk';
$variables->{cmd_read}       = 'read';
$variables->{cmd_std}        = 'std';
$variables->{cmd_raw}        = 'raw';
$variables->{cmd_list}       = 'list';
$variables->{cmd_home}       = 'home';
$variables->{cmd_sort}       = 'sort';

# return messages
$variables->{bigmsg}        = 'The message was too long, check raw and contact sender.';
$variables->{nosender}       = 'You have entered no valid Email-Address.';
$variables->{nosubject}      = 'You have not entered a valid subject.';
$variables->{nocontent}      = 'You have entered no content.';
$variables->{noresults}      = 'There were no results.';
$variables->{forwarded}      = 'forwarded from:';
$variables->{ref_id_subject} = 'The ref Id was found in the subject line.';
$variables->{deleted}        = 'The record was deleted.';

# enum fields
# ascending / descending
$variables->{ad_asc}         = 'ascending';
$variables->{ad_desc}        = 'descending';

# work status
$variables->{ws_new}         = 'new';
$variables->{ws_reply_mail}  = 'mail-reply';
$variables->{ws_reply_misc}  = 'misc';
$variables->{ws_noreply}     = 'no reply';
$variables->{ws_sent}        = 'sent';

# view status
$variables->{vs_open}        = 'open';
$variables->{vs_library}     = 'pool';
$variables->{vs_faq}         = 'FAQ';
$variables->{vs_junk}        = 'Junk';

# rating
$variables->{rt_top}         = 'top';
$variables->{rt_medium}      = 'medium';
$variables->{rt_bad}         = 'bad';
$variables->{rt_again}       = 'again';
$variables->{rt_unrated}     = 'unrated';

# source
$variables->{sc_yes}         = 'Yes';
$variables->{sc_no}          = 'No';

# source
$variables->{ss_admin}       = 'admin';
$variables->{ss_regular}     = 'regular';

# display of field names
# fields of category table
$variables->{cf_id}          = 'ID';
$variables->{cf_name}        = 'Name';
$variables->{cf_father}      = 'FatherCategory';

# fields of default table
$variables->{df_id}          = 'ID';
$variables->{df_subject}     = 'Subject';
$variables->{df_content}     = 'Content';

# fields of list table
$variables->{lf_id}          = 'ID';
$variables->{lf_ref_id}      = 'ref ID';
$variables->{lf_category_id} = 'Category';
$variables->{lf_owner}       = 'Owner';
$variables->{lf_sender}      = 'Sender';
$variables->{lf_subject}     = 'Subject';
$variables->{lf_content}     = 'Content';
$variables->{lf_comment}     = 'Comment';
$variables->{lf_tstmp}       = 'Timestamp';
$variables->{lf_work_status} = 'work status';
$variables->{lf_view_status} = 'view status';
$variables->{lf_rating}      = 'rating';
$variables->{lf_source}      = 'source';

# fields of user table
$variables->{uf_userid}     = 'username';
$variables->{uf_name}       = 'Name';
$variables->{uf_given}      = 'First';
$variables->{uf_pass}       = 'Pass';
$variables->{uf_access}     = 'Access';
$variables->{uf_default_top}    = 'Default-header';
$variables->{uf_default_bottom} = 'Default-footer';

# misc
$variables->{ms_mailto}    = 'To';
$variables->{ms_mailfrom}  = 'From';
$variables->{ms_attachment}= 'Attachment';

################################################################
# error messages for output
################################################################

$error_message->{'duplicate'}= "User already exists.";
$error_message->{'userparam'}= "Please only use letters and numbers (at least 5).";
$error_message->{'noid'}     = "You have entered no or no valid ID.";
$error_message->{'norating'} = "You have not entered a valid rating.";
$error_message->{'nofile'}   = "The file could not be found:";
$error_message->{'nouser'}   = "You are not logged in as a user.";
$error_message->{'nouserid'} = "This userid is not in our database.";
$error_message->{'noirreg'}  = "Please only use letters and numbers and _ as spacer.";
1;