####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: GLOBAL.pm
#  Description: subroutines for prosupporter
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################

use strict;
use DBI;
package GLOBAL;

################################################################
# error output
################################################################

sub error {
my ($error_msg,$data);
my $error_input    = $_[0];
   $data->{error_message} = $CONFIG::error_message->{$error_input};
   &template('error',$data);
   exit;
}

################################################################
# user
################################################################

sub user {
my ($user,$record);
my (@ary);
#   $user->{userid} = "test";
   $user->{userid} = $ENV{'REMOTE_USER'} || undef;
   if (!$user->{userid}) {&error('nouser')};
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
my $sth = $dbh->prepare (qq~SELECT * FROM $CONFIG::staff_table WHERE userid LIKE '$user->{userid}'~);
   $sth->execute ();
   @ary = $sth->fetchrow_array ();
   $user->{userid}         = $ary[0];
   $user->{name}           = $ary[1];
   $user->{given}          = $ary[2];
   $user->{pass}           = $ary[3];
   $user->{access}         = $ary[4];
   $user->{default_top}    = $ary[5];
   $user->{default_bottom} = $ary[6];
   $sth->finish ();
   $dbh->disconnect ();
   if ($sth->rows < 1) {&error('novaliduser');}
   return $user;
}

################################################################
# parse and print template
################################################################

sub template {
my $path;
my $template   = $_[0] || "error";
my $data       = $_[1] || undef;
my $navigation = $_[2] || undef;
my $output;
if (!$ENV{REMOTE_USER}) {$path = "./admin/templates/";}
else {$path = "./templates/";}
if ($navigation) {
open (DATA, $path . $navigation . ".html") || die qq~$CONFIG::error_message->{'nofile'} .:|$navigation.html|:.\n~;
while (my $line = <DATA>) {$CONFIG::variables->{navigation_left} .= $line;}
close(DATA);
}
open (DATA, $path . "navigation_top" . ".html") || die qq~$CONFIG::error_message->{'nofile'} .:|navigation_top.html|:.\n~;
while (my $line = <DATA>) {$CONFIG::variables->{navigation_top} .= $line;}
close(DATA);
open (DATA, $path . $template . ".html") || die qq~$CONFIG::error_message->{'nofile'} .:|$template.html|:.\n~;
while (my $line = <DATA>) {
    my $line_copy = '';
    my $changes = 0;
    # search for variables in the current line
    while ($line =~ /<%([^>]+)%>/) {
        # build up the new line with the section of $line prior to the
        # variable and the value for $var_name (check %variables, %config)
        ++$changes;
       if ($data->{$1}) { $line_copy .= $` . $data->{$1} }
       elsif ($CONFIG::variables->{$1}) { $line_copy .= $` . $CONFIG::variables->{$1} }
       else {
           --$changes;
           $line_copy .= $`;
           }
       # change $line to the section of $line after the variable
       $line = $';
    }
    # set $line according to whether or not any matches were found
    $line = $line_copy ? $line_copy . $line : $line;
    # print line depending on presence of 0: and variables existing
    if (($line !~ s/^0://) || !$line_copy || $changes) { $output .= $line; }
}
close(DATA);
$output =~ s/<\/body>/<p align=center><small>&copy; script by <a href=http:\/\/www.tulba.com\/>Tulba.com<\/a><br><br><\/p>/i;
print $output;
exit;
}

################################################################
#       date and time &datetime(format) eg ddmmyyyy
################################################################

sub datetime {
my ($output) = @_;
my ($year,$mon,$day,$hour,$min,$sec,$z1,$z2,$z3,$z4,$z5);
my $z3 = $z4 = $z1 = $z2 = "";
   ($sec,$min,$hour,$day,$mon,$year,undef,undef,undef) = localtime(time);
   $mon++;
   $year += 1900;
   if ($day < 10) { $z2 = "0"; }
   if ($mon < 10) { $z1 = "0"; }
   if ($hour < 10) { $z3 = "0"; }
   if ($min < 10) { $z4 = "0"; }
   if ($sec < 10) { $z5 = "0"; }
   if ($output eq 'ddmmyyyy') { return "$z2$day.$z1$mon.$year"; }
   if ($output eq 'yyyy') { return "$year"; }
   if ($output eq 'tstmpm') { return "$year$z1$mon"; }
   if ($output eq 'tstmpd') { return "$year$z1$mon$z2$day"; }
   if ($output eq 'tstmp') { return "$year$z1$mon$z2$day$z3$hour$z4$min$z5$sec"; }
}

################################################################
# add something to database with &add_data('hash','table');
################################################################

sub add_data {
my %derefHash;
my ($key,$dbh);
my ($query_name,$query_value);
my $hashref;
my $results;
$hashref   = $_[0];
%derefHash = %$hashref;
foreach $key (keys(%derefHash)) {
        if ($key eq "action") {next;}
        if ($key eq "order_by") {next;}
        if ($key eq "asc_desc") {next;}
        $results->{table_results} .= qq~<tr><td class=left>~ . $key . qq~</td><td class=right>~ . ($derefHash{"$key"}) . qq~&nbsp;</td></tr>\n~;
        $derefHash{"$key"} =~ s/\'/\\\'/g;
        $derefHash{"$key"} =~ s/\"/\\\"/g;
        $query_name .= $key . qq~,~;
        $query_value .= qq~'~ . ($derefHash{"$key"}) . qq~',~;
        }
chop $query_name;
chop $query_value;
$results->{query} = "INSERT " . $_[1] . " (" . $query_name . ") VALUES (" . $query_value . ")";
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
   $dbh->do (qq~$results->{query}~);
   $results->{used_id} = $dbh->{mysql_insertid};
   $results->{table_name} = $_[1];
   $dbh->disconnect ();
   return $results;
}

################################################################
# modify some data with &modify(hash,table)
################################################################

sub modify_data {
my %derefHash;
my ($key,$name,$table,$dbh,$results,$hashref);
my $hashref = $_[0];

$results->{query} = qq~UPDATE $_[1] SET ~;
%derefHash=%$hashref;
foreach $key (keys(%derefHash)) {
        if ($key eq "action") {next;}
        if ($key eq "order_by") {next;}
        if ($key eq "asc_desc") {next;}
        if ($key eq "id" || $key eq "userid") {$results->{id} = ($derefHash{"$key"});$results->{id_field} = $key;next;}
        $results->{'table_results'} .= qq~<tr><td class=left>~ . $key . qq~</td><td class=right>~ . ($derefHash{"$key"}) . qq~&nbsp;</td></tr>\n~;
        $derefHash{"$key"} =~ s/\'/\\\'/g;
        $derefHash{"$key"} =~ s/\"/\\\"/g;
        $results->{query} .= $key . qq~ = '~ . ($derefHash{"$key"}) . qq~',~;
        }
chop $results->{query};
$results->{query} .= qq~WHERE $results->{id_field} LIKE '$results->{id}'~;
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
   $dbh->do (qq~$results->{query}~);
   $dbh->disconnect ();
   $results->{table_name} = $_[1];
   return $results;
}

################################################################
# get one single record &get_record(id,table);
################################################################

sub get_record {
my $results;
   $results->{id} = $_[0];
   $results->{table} = $_[1];
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
my $sth = $dbh->prepare (qq{ SELECT * FROM $results->{table} WHERE 1 = 0 } );
   $sth->execute ();
my (@col_name) = @{$sth->{NAME}};
   $sth->finish ();
   $sth = $dbh->prepare (qq~SELECT * FROM $results->{table} WHERE $col_name[0] LIKE '$results->{id}'~);
   $sth->execute ();
my @ary = $sth->fetchrow_array ();
   $sth->finish ();
   $dbh->disconnect ();
my $cols = @col_name;
   for(my $i = 0;$i <= $cols;$i++) {$results->{$col_name[$i]} = $ary[$i];}
   return $results;
}

################################################################
# search database &search_data(hash,table)
################################################################

sub search_data {
my $in = new CGI;
my ($key,$value,$flag,$results);
my (@vars);
   $results->{table} = $_[1];
   $results->{query} = qq~SELECT * FROM $results->{table} WHERE ~;
my $hashref = $_[0];
my %derefHash=%$hashref;
foreach $key (keys(%derefHash)) {
        if ($key eq "action") {next;}
        if ($key eq "order_by") {next;}
        if ($key eq "asc_desc") {next;}
        $value = $in->param($key);
        $value =~ s/\'/\\\'/g;
        $value =~ s/\"/\\\"/g;
        if ($value) {$results->{query} .= qq~ $key LIKE '$value'~; $flag = 1;}
        else {$flag = undef;}
        if ($flag eq "1") { $results->{query} .= " AND";}
        }
chop $results->{query};
chop $results->{query};
chop $results->{query};
chop $results->{query};
return $results;
}

################################################################
# delete record &delete_record(col,value,table)
################################################################

sub delete_record {
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
my $sth = $dbh->prepare (qq~DELETE FROM $_[2] WHERE $_[0] LIKE '$_[1]'~);
   $sth->execute ();
   $sth->finish ();
   $dbh->disconnect ();
return $sth->rows;
}

################################################################
# get category drop down;
################################################################

sub get_cat {
my $results;
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
my $sth = $dbh->prepare (qq~SELECT * FROM $CONFIG::category_table ORDER BY name~);
   $sth->execute ();
   if ($_[0] eq "numlist") {while (my @ary = $sth->fetchrow_array ()) {if ($ary[0] eq 1) {$ary[1] = "/";}$results->{$ary[0]} = $ary[1];}}
   else {
      while (my @ary = $sth->fetchrow_array ()) {
         if ($ary[0] eq 1) {$ary[1] = "/";}
         if ($ary[0] eq $_[0]) {next;}
         $results .= qq~<option value=$ary[0]>$ary[1]</option>~;
      }
   }
   $sth->finish ();
   $dbh->disconnect ();
   return $results;
}

################################################################
# get dropdown from enum &get_dropdown(table,field,output)
# where output can be checkbox,form or option
################################################################

sub get_dropdown {
my ($option,$results,$flag);
my (@options);
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { RaiseError => 1 });
my $sth = $dbh->prepare (qq~DESCRIBE $_[0]~);
   $sth->execute ();
      while (my @ary = $sth->fetchrow_array ()) {
         if ($ary[0] eq "$_[1]") {
         $ary[1] =~ s/enum\(//g;
         $ary[1] =~ s/\)//g;
         $ary[1] =~ s/\'//g;
         @options = split(/,/, $ary[1]);
         @options = sort (@options);
            foreach $option (@options) {
               if ($_[2] eq "checkbox") {$results .= qq~<input type="checkbox" name="$option" value="1" checked>$option\n~;}
               elsif ($_[2] eq "form") {
                  if ($flag eq "1") {$results .= qq~,~;}
                  $results .= qq~'$option'~;
                  $flag = 1;
                  }
               elsif ($_[2] eq "option") {$results .= "<option>$option</option>";}
               else {$results .= $option . "\n";}
               }
         }
         else {next;}
      }
   $sth->finish ();
$dbh->disconnect ();
return $results;
}
1;