#!/usr/bin/perl
####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: new_messages.cgi
#  Description: handle new support requests
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################
$0 =~ /^(.*)[\/\\].*/ && chdir ($1) ; $|=1;
use strict;
use CGI();
use CGI::Carp('fatalsToBrowser');
use DBI;
use lib './modules';
use GLOBAL;
use CONFIG;
use Mail::POP3Client;
use Email::Find;
use MIME::Lite;
use URI::Escape qw(uri_escape uri_unescape);
use MIME::Parser;
my $in = new CGI;
   print $in->header();
my ($data,$i);
my $user = &GLOBAL::user;
my ($data,$dbh,$sth);
my (@ary);
my $span_page = $in->param('page') || 1;
   $span_page =~ s/[^\d+]//g;
   $span_page--;
   $data->{action} = $in->param('action') || undef;
   $data->{id} = $in->param('id') || undef;
   if ($data->{id}) {
      $data = &GLOBAL::get_record($data->{id},$CONFIG::list_table);
      $data->{ticketid} = $data->{ref_id};
      $data->{action} = $in->param('action');
      $data->{pop} = $CONFIG::pop_user;
      $data->{top_default} = $user->{default_top};
      $data->{bottom_default} = $user->{default_bottom};
      $data->{message_to} = $in->param('to') || undef;
      $data->{message_subject} = $in->param('subject') || undef;
      $data->{message_content} = $in->param('content') || undef;
      $data->{message_attach} = $in->param('attach') || undef;
      $data->{message_comment} = $in->param('comment') || undef;
      $data->{new_owner} = $in->param('new_owner') || undef;
      &owner($data->{id});
      if ($data->{action} eq 'read') {
         $data->{std_list} = qq~<option value=""></option>~;
         my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
         my $sth = $dbh->prepare (qq{ SELECT id,subject FROM $CONFIG::default_table} );
         $sth->execute ();
         while (my @ary = $sth->fetchrow_array ()) {$data->{std_list} .= qq~<option value=$ary[0] class=results>$ary[1]</option>~;}
         $sth->execute ();
         $sth->finish ();
         $dbh->disconnect ();
         $data->{tstmp} = substr($data->{tstmp},6,2) . "-" . substr($data->{tstmp},4,2) . "-" . substr($data->{tstmp},0,4) . " " . substr($data->{tstmp},8,2) . ":" . substr($data->{tstmp},10,2);
         $data->{content} =~ s/\n/<br>/g;
         $data->{comment} =~ s/\n/<br>/g;
         &GLOBAL::template('newmsg_read',$data,'navigation_new_messages');
      }
      if ($data->{action} eq 'raw') {
         $data->{std_list} = qq~<option value=""></option>~;
         my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
         my $sth = $dbh->prepare (qq{ SELECT id,subject FROM $CONFIG::default_table} );
         $sth->execute ();
         while (my @ary = $sth->fetchrow_array ()) {$data->{std_list} .= qq~<option value=$ary[0] class=results>$ary[1]</option>~;}
         $sth->execute ();
         $sth->finish ();
         $dbh->disconnect ();
         $data->{content} = undef;
         open(DATA, "./data/$data->{id}/content.txt") || die &GLOBAL::error('nofile');
         while (my $line = <DATA>) {$data->{content} .= $line;}
         close(DATA);
         $data->{content} = qq~<pre>$data->{content}</pre>~;
         $data->{comment} =~ s/\n/<br>/g;
         &GLOBAL::template('newmsg_read',$data,'navigation_new_messages');
      }
      if ($data->{action} eq 'sendmail') {
         if ($data->{message_to} && $data->{message_content}) {&sendmail;}
         else {&chown;&std;&GLOBAL::template('newmsg_mailform',$data,'navigation_new_messages');}
      }
      if ($data->{action} eq 'misc') {
         if ($data->{message_comment}) {&setmisc;}
         else {&chown;&GLOBAL::template('newmsg_miscform',$data,'navigation_new_messages');}
      }
      if ($data->{action} eq 'fwd') {
         if ($data->{new_owner}) {&setfwd;}
         else {&chown;&fwdform;}
      }
      if ($data->{action} eq 'junk') {&chown;&junk}
   }
   elsif ($data->{action} eq "get_mail") {
   my $pop = new Mail::POP3Client (HOST => $CONFIG::pop_host);
      $pop->User ($CONFIG::pop_user);
      $pop->Pass ($CONFIG::pop_pass);
      $pop->Connect();
      if ($pop->Count() >= 1) {$data->{new_messages} = "&gt;" . $pop->Count() . "&lt;";}
      elsif ($pop->Count() == -1) {$data->{new_messages} = "POP3 -1";}
      else {$data->{new_messages} = "&gt;0&lt;";}
      for ($i = 1; $i <= $pop->Count(); $i++) {
          my ($msgnum, $size) = split ' ', $pop->List($i);
          $data = undef;
          $data->{work_status} = 'new';
          $data->{owner} = 'service';
          my @mail_content = split(/\n/,$pop->HeadAndBody($i));
          #if ($size > $CONFIG::pop_size) {$data->{content} = $CONFIG::variables->{bigmsg};}
          #else {$data->{content} = $pop->Body($i);}
          #$data->{content} = $pop->Body($i);
          foreach ($pop->Head($i)) {
             if ($_ =~ /From/) {find_emails($_, sub {my($email, $orig_email) = @_;$data->{sender} = $email->format;return $orig_email;});}
             /^(Subject):\s+/i and $data->{subject} = $_; $data->{subject} =~ s/Subject: //g;}
          if ($data->{subject} =~ /\[ID(.*)\]/) {
             $data->{ref_id} = $data->{subject};
          my @ref_id = split(/]/,$data->{ref_id});
             $ref_id[0] =~ s/\[ID(.*)/$1/;
             $ref_id[0] =~ s/[^0-9]//g;
             $data->{ref_id} = $ref_id[0];
             $data->{comment} = $CONFIG::variables->{ref_id_subject};
          }
          $data->{subject} = &convert($data->{subject});
       my $record = &GLOBAL::add_data($data,$CONFIG::list_table);
          $data->{id} = $record->{used_id};
          if ($data->{ref_id} > 1) {$data->{ref_id} = $data->{ref_id};}
          else {$data->{ref_id} = $record->{used_id};}
#attachment
my $message="";
foreach ($pop->HeadAndBody($i)) {$message.=$_."\n";}
my $parser = new MIME::Parser;
unless (-e "./data/$record->{used_id}") {if (mkdir ("./data/$record->{used_id}")) {chmod(0777,"./data/$record->{used_id}");}}
$parser->output_dir("./data/$record->{used_id}");
my $entity = $parser->parse_data($message);
my $attachref=[];
my $messagestored = &decodemail($entity,$attachref,1,$record->{used_id});
my @attach=@{$attachref};
my $attach;
$data->{content} = $messagestored;
$data->{content} = &convert($data->{content});
#attachment
          open(DATA, ">>./data/$record->{used_id}/content.txt") || die &GLOBAL::error('nofile');
       my $mod = chmod 0774, "./data/$record->{used_id}/content.txt";
          foreach my $zeile(@mail_content){$zeile = &convert($zeile);print DATA "$zeile";}
          close(DATA);
          $data->{content} =~ s/<[^>]*>//gs;
          &GLOBAL::modify_data($data,$CONFIG::list_table);
          $pop->Delete($i);
      }
      $pop->Close();
      &get_list;
      &GLOBAL::template('newmsg_get_mail',$data,'navigation_new_messages');
   }
   elsif ($data->{action} eq "create") {
         $data->{tstmp} = &GLOBAL::datetime('tstmp');
         $data->{rating} = "unrated";
         $data->{source} = "yes";
         $data->{work_status} = "new";
         $data->{owner} = $ENV{REMOTE_USER};
         $data->{sender} = $in->param('to') || undef;
         $data->{subject} = $in->param('subject') || undef;
         $data->{content} = $in->param('content') || undef;
      my $record = &GLOBAL::add_data($data,$CONFIG::list_table);
         $data->{id} = $record->{used_id};
         $data->{ref_id} = $record->{used_id};
         $data->{content} =~ s/<[^>]*>//gs;
         &GLOBAL::modify_data($data,$CONFIG::list_table);
         unless (-e "./data/$data->{id}") {if (mkdir ("./data/$data->{id}")) {chmod(0777,"./data/$data->{id}");}}
         open(DATA, ">>./data/$data->{id}/content.txt") || die &GLOBAL::error('nofile');
      my $mod = chmod 0774, "./data/$data->{id}/content.txt";
         print DATA qq~$data->{sender}\n\n$data->{subject}\n\n$data->{content}~;
         close(DATA);
         $data->{work_status} = $CONFIG::variables->{"ws_" . $data->{work_status}};
         $data->{view_status} = $CONFIG::variables->{"vs_" . $data->{view_status}};
         $data->{rating} = $CONFIG::variables->{"rt_" . $data->{rating}};
         $data->{source} = $CONFIG::variables->{"sc_" . $data->{source}};
         &get_list;
         &GLOBAL::template('newmsg_created',$data,'navigation_new_messages');
   }
   elsif ($data->{action} eq "create_form") {
      $data->{category_list} = &GLOBAL::get_cat;
      &GLOBAL::template('newmsg_createform',$data,'navigation_new_messages');
   }
   else {&get_list;&GLOBAL::template('newmsg_list',$data,'navigation_new_messages');}
exit;
####################################################################
# subroutines
####################################################################
####################################################################
# owner
####################################################################
sub owner {
   if (($data->{owner} eq "service" || $data->{owner} eq "$user->{userid}" ) && $data->{work_status} eq "new") {return;}
   else {&get_list;&GLOBAL::template('newmsg_noowner',$data,'navigation_new_messages');}
   return;
}

####################################################################
# send eMail and show the list
####################################################################
sub sendmail {
   my $message = MIME::Lite->new(
              From     => $CONFIG::variables->{adminmail},
           To       => $data->{message_to},
           Subject  => $data->{message_subject},
           Type     => 'text/plain',
           Encoding => '8bit',
           Data     => $data->{message_content}
   );
   if ($data->{message_attach}) {
           my $tmp_file = $in->tmpFileName($data->{message_attach});
              $data->{message_attach}=~m/^.*(\\|\/)(.*)/;
           my $filename = $2;
           my $mime_type = 'application/octet-stream';
           my $encoding = 'base64';
           $message->attach (
                   Type     => $mime_type ,
                   Encoding => $encoding ,
                   Path     => $tmp_file ,
                   Filename => $filename
            );
                $data->{message_content} .= "\n\nAttachment: $filename";
    }
   MIME::Lite->send("sendmail", "/usr/sbin/sendmail -t -oi -oem");
   $message->send;
my $hashref;
   $hashref->{id} = $data->{id};
   $data->{work_status} = $in->param('work_status') || undef;
   if ($data->{work_status} eq "new") {$hashref->{work_status} = "new";}
   else {$hashref->{work_status} = "reply_mail";}
   &GLOBAL::modify_data($hashref,$CONFIG::list_table);
   $hashref->{id} = undef;
   $hashref->{ref_id} = $data->{ref_id};
   $hashref->{work_status} = "sent";
   $hashref->{sender} = $data->{message_to};
   $hashref->{subject} = $data->{message_subject};
   $hashref->{owner} = $user->{userid};
   $hashref->{content} = $data->{message_content};
my $added = &GLOBAL::add_data($hashref,$CONFIG::list_table);
   unless (-e "./data/$added->{used_id}") {if (mkdir ("./data/$added->{used_id}")) {chmod(0777,"./data/$added->{used_id}");}}
   open(DATA, ">>./data/$added->{used_id}/content.txt") || die &GLOBAL::error('nofile');
my $mod = chmod 0774, "./data/$added->{used_id}/content.txt";
   print DATA qq~From: $data->{pop}\nTo: $data->{message_to}\nSubject: $data->{message_subject}\nContent: $data->{message_content}~;
   close(DATA);
   &get_list();
   &GLOBAL::template('newmsg_mailsent',$data,'navigation_new_messages');
}
####################################################################
# setmisc
####################################################################
sub setmisc {
my $hashref;
   $hashref->{id} = $in->param('id');
   $hashref->{work_status} = "reply_misc";
   $hashref->{comment} = $data->{comment} . "\n" . $in->param('comment') . "|";
   &GLOBAL::modify_data($hashref,$CONFIG::list_table);
   &get_list;
   &GLOBAL::template('newmsg_miscset',$data,'navigation_new_messages');
}
####################################################################
# chown
####################################################################
sub chown {
my $hashref;
   $hashref->{id} = $in->param('id');
   $hashref->{owner} = $user->{userid};
   &GLOBAL::modify_data($hashref,$CONFIG::list_table);
   return;
}
####################################################################
# setfwd
####################################################################
sub setfwd {
my $hashref;
   $hashref->{id} = $in->param('id');
   $hashref->{comment} = $data->{comment} . "\n $CONFIG::variables->{forwarded} " . $user->{userid} . " -&gt; " . $data->{new_owner} . "\n " . $data->{message_comment} . "|";
   $hashref->{owner} = $data->{new_owner};
   &GLOBAL::modify_data($hashref,$CONFIG::list_table);
&get_list();
&GLOBAL::template('newmsg_fwdset',$data,'navigation_new_messages');
}
####################################################################
# fwdform
####################################################################
sub fwdform {
$dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
$sth = $dbh->prepare (qq~SELECT userid FROM $CONFIG::staff_table ORDER BY userid~);
$sth->execute ();
$data->{staff_drop} = '<option value=service>service</option>\n';
while (@ary = $sth->fetchrow_array ()) {$data->{staff_drop} .= "<option value=$ary[0]>$ary[0]</option>\n";}
$sth->finish ();
$dbh->disconnect ();
&GLOBAL::template('newmsg_fwdform',$data,'navigation_new_messages');
}
####################################################################
# junk
####################################################################
sub junk {
my $hashref;
   $hashref->{id} = $in->param('id');
   $hashref->{owner} = $user->{userid};
   $hashref->{work_status} = "noreply";
   &GLOBAL::modify_data($hashref,$CONFIG::list_table);
&get_list();
&GLOBAL::template('newmsg_junk',$data,'navigation_new_messages');
}
####################################################################
# get_list
####################################################################
sub get_list {
my $bi = 1;
$data->{std_list} = qq~<option value=""></option>~;
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
my $sth = $dbh->prepare (qq{ SELECT id,subject FROM $CONFIG::default_table} );
$sth->execute ();
while (my @ary = $sth->fetchrow_array ()) {$data->{std_list} .= qq~<option value=$ary[0] class=results>$ary[1]</option>~;}
$sth->execute ();
$sth->finish ();
$sth = $dbh->prepare (qq{ SELECT id FROM $CONFIG::list_table WHERE (owner like '$user->{userid}' or owner like 'service') and work_status like 'new'} );
$sth->execute ();
$sth->finish ();
$data->{count} = $sth->rows;
if ($data->{count} > $CONFIG::variables->{recordsppage}) {
   my $pages = $data->{count} / $CONFIG::variables->{recordsppage};
   $pages = int($pages);
   if (($data->{count} / $CONFIG::variables->{recordsppage}) ne $pages) {$pages++;}
   $data->{span_page} = "[";
   for ( my $j = 1 ; $j <= $pages ; $j++ ) {
      if ($j eq ($span_page+1)) {$data->{span_page} .= " $j |";}
      else {$data->{span_page} .= qq~ <a href=$CONFIG::variables->{url}/admin/new_messages.cgi?page=$j>$j</a> |~;}
      }
   chop $data->{span_page};
   $data->{span_page} .= "]";
}
$span_page = $span_page * $CONFIG::variables->{recordsppage};
$sth = $dbh->prepare (qq{ SELECT id,sender,subject,comment,owner,tstmp FROM $CONFIG::list_table WHERE (owner like '$user->{userid}' or owner like 'service') and work_status like 'new' order by owner, id desc LIMIT $span_page, $CONFIG::variables->{recordsppage}} );
$sth->execute ();
while (my @ary = $sth->fetchrow_array ()) {
    my $stmpformated = substr($ary[5],6,2) . "-" . substr($ary[5],4,2) . "-" . substr($ary[5],0,4) . " " . substr($ary[5],8,2) . ":" . substr($ary[5],10,2);
    if ($bi/2 == int ($bi/2) ) {$data->{bgcolor} = $CONFIG::variables->{listbgcolor1};}
    else {$data->{bgcolor} = $CONFIG::variables->{listbgcolor2};}
    $bi++;
    if (length($ary[2]) > 50) {$ary[2] = substr($ary[2], 0, 50) . "...";}
    $ary[3] =~ s/\n/<BR>\n/g;
    $data->{list} .= qq~
                                     <form method="POST" action="new_messages.cgi" enctype="multipart/form-data">
                                     <tr>
                                        <td style="background:#$data->{bgcolor}" class=results rowspan=2>$ary[0]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[1]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[3]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[4]</td>
                                        <td style="background:#$data->{bgcolor}" class=results><a href=new_messages.cgi?action=read&id=$ary[0]>$CONFIG::variables->{cmd_read}</a></td>
                                        <td style="background:#$data->{bgcolor}" class=results><a href=new_messages.cgi?action=sendmail&id=$ary[0]>$CONFIG::variables->{cmd_mail}</a></td>
                                        <td style="background:#$data->{bgcolor}" class=results><a href=new_messages.cgi?action=misc&id=$ary[0]>$CONFIG::variables->{cmd_misc}</a></td>
                                        <td style="background:#$data->{bgcolor}" class=results><a href=new_messages.cgi?action=fwd&id=$ary[0]>$CONFIG::variables->{cmd_fwd}</a></td>
                                        <td style="background:#$data->{bgcolor}" class=results><a href=new_messages.cgi?action=junk&id=$ary[0]>$CONFIG::variables->{cmd_junk}</a></td>
                                     </tr>
                                     <tr>
                                        <td style="background:#$data->{bgcolor}" class=results colspan=2>&nbsp;$ary[2]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>$stmpformated</td>
                                        <td style="background:#$data->{bgcolor}" colspan=5 class=results>
                                        <nobr>
                                        <input type=hidden name=action value=sendmail>
                                        <input type=hidden name=id value=$ary[0]>
                                        <select class=results name=std>
                                        $data->{std_list}
                                        </select>
                                        <input type="submit" value="$CONFIG::variables->{cmd_std}" class=results></nobr>
                                        </td>
                                     </tr>
                                     </form>~;
}
if ($data->{count} < 1) {$data->{list} = qq~<tr><td colspan=11>$CONFIG::variables->{'noresults'}</td></tr>~;$data->{count} = "&gt;0&lt;";}
$sth->finish ();
$dbh->disconnect ();
return;
}
####################################################################
# if there is a std id submitted get std message for reply mail
####################################################################
sub std {
my $std = $in->param('std') || undef;
unless ($std) {return;}
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 0 });
my $sth = $dbh->prepare (qq{ SELECT subject,content FROM $CONFIG::default_table where id like $std} );
   $sth->execute ();
my @ary = $sth->fetchrow_array ();
   $data->{std_subject} = "/" . $ary[0];
   $data->{std_content} = $ary[1];
   $sth->finish ();
   $dbh->disconnect ();
   return;
}
####################################################################
#   convert try to change some of the ****!#x
####################################################################
sub convert {
   my $convert = $_[0];
      $convert =~ s/=09/\t/g;
      $convert =~ s/=20/ /g;
      $convert =~ s/=c4//g;
      $convert =~ s/=d6//g;
      $convert =~ s/=dc//g;
      $convert =~ s/=df/ss/g;
      $convert =~ s/=e4//g;
      $convert =~ s/=f6//g;
      $convert =~ s/=fc//g;
      $convert =~ s/=4c/&lt;/g;
      $convert =~ s/=4e/&gt;/g;
      $convert =~ s/=C4//g;
      $convert =~ s/=D6//g;
      $convert =~ s/=DC//g;
      $convert =~ s/=DF/ss/g;
      $convert =~ s/=E4//g;
      $convert =~ s/=F6//g;
      $convert =~ s/=FC//g;
      $convert =~ s/=4C/&lt;/g;
      $convert =~ s/=4E/&gt;/g;
      return $convert;
}
####################################################################
#   convert try to change some of the ****!#x
####################################################################
sub decodemail {
my ($entity,$attach,$preformat,$id)=@_;
my $messagestored="";
my $bodysend="";
my $i;
my $j;
my $k=0;
my $globaltype=$entity->mime_type;
if ($entity->parts) {
   for ($i=0;$i<$entity->parts;$i++) {
      my $ent=$entity->parts($i);
      my $type = lc($ent->mime_type);
      my $body = $ent->bodyhandle;
      if ($body) {
         if ($type=~ m/text/) {
            $messagestored.= $body->as_string;
         } elsif ($type=~ m/image\//i) {
            my $path = $body->path;
            $path =~ m/^.*(\\|\/)(.*)/;
            my $img=$2;
            my $fichn=$img;
            $attach->[$k]=$fichn;
            $k++;
            $data->{comment} .= "<a href=\"$CONFIG::variables->{url}/admin/data/$id/$fichn\" target=_blank>$fichn</a>\n";
         } elsif ($type=~ m/message\/rfc/i) {
            my $attachinside=[];
            my $parser = new MIME::Parser;
            $parser->output_dir("./data/$id");
            $parser->output_prefix("msginside");
            my $entityinside= $parser->parse_data($body->as_string);
            my $l;
            for ($l=0; $l< scalar(@{$attachinside}); $l++) { $attach->[$k]=$attachinside->[$l]; $k++; }
         } else {
            my $path = $body->path;
            $path =~ m/^.*(\\|\/)(.*)/;
            my $fichn=$2;
            $attach->[$k]=$fichn;
            $data->{comment} .= "<a href=\"$CONFIG::variables->{url}/admin/data/$id/$fichn\" target=_blank>$fichn</a>\n";
            $k++;
         }
      }
   }
} else {
   my $body = $entity->bodyhandle;
   my $type = lc($entity->mime_type);
   if ($type=~ m/text/i || $type=~ m/message/i) {$messagestored.= $body->as_string;}
   $entity->purge;
   }
return $messagestored;
}
1;