#!/usr/bin/perl
####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: old_messages.cgi
#  Description: handle answered messages
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################
$0 =~ /^(.*)[\/\\].*/ && chdir ($1) ; $|=1;
use strict;
use CGI();
use CGI::Carp('fatalsToBrowser');
use DBI;
use lib './modules';
use GLOBAL;
use CONFIG;
my $in = new CGI;
   print $in->header();
my $data;
my $user = &GLOBAL::user;
my $span_page = $in->param('page') || 1;
   $span_page =~ s/[^\d+]//g;
   $span_page--;
   $data->{action} = $in->param('action');
   $data->{id} = $in->param('id') || undef;
   $data->{ref_id} = $in->param('ref_id') || undef;
   $data->{category_id} = $in->param('category_id') || undef;
   $data->{owner} = $in->param('owner') || undef;
   $data->{sender} = $in->param('sender') || undef;
   $data->{subject} = $in->param('subject') || undef;
   $data->{content} = $in->param('content') || undef;
   $data->{comment} = $in->param('comment') || undef;
   $data->{tstmp} = $in->param('tstmp') || undef;
   $data->{work_status} = $in->param('work_status') || undef;
   $data->{view_status} = $in->param('view_status') || undef;
   $data->{rating} = $in->param('rating') || undef;
   $data->{source} = $in->param('source') || undef;
   $data->{order_by} = $in->param('order_by') || 'id';
   $data->{asc_desc} = $in->param('asc_desc') || 'desc';
   if ($data->{action} eq "search") {
      my $string = &GLOBAL::search_data($data,$CONFIG::list_table);
      my $numlist = &GLOBAL::get_cat('numlist');
      my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });

      $data->{query} =~ s/\*/id/g;
      my $sth = $dbh->prepare (qq{$string->{query} and work_status not like 'new'});
      $sth->execute ();
      $sth->finish ();
      $data->{count} = $sth->rows;
      if ($data->{count} > $CONFIG::variables->{recordsppage}) {
         my $pages = $data->{count} / $CONFIG::variables->{recordsppage};
         $pages = int($pages);
         if (($data->{count} / $CONFIG::variables->{recordsppage}) ne $pages) {$pages++;}
         $data->{span_page} = "[";
         for ( my $j = 1 ; $j <= $pages ; $j++ ) {
            if ($j eq ($span_page+1)) {$data->{span_page} .= " $j |";}
            else {$data->{span_page} .= qq~ <a href="$CONFIG::variables->{url}/admin/old_messages.cgi?action=search&page=$j&id=$data->{id}&ref_id=$data->{ref_id}&category_id=$data->{category_id}&owner=$data->{owner}&sender=$data->{sender}&subject=$data->{subject}&content=$data->{content}&comment=$data->{comment}&tstmp=$data->{tstmp}&work_status=$data->{work_status}&view_status=$data->{view_status}&rating=$data->{rating}&source=$data->{source}&order_by=$data->{order_by}&asc_desc=$data->{asc_desc}">$j</a> |~;}
         }
         chop $data->{span_page};
         $data->{span_page} .= "]";
      }
      $span_page = $span_page * $CONFIG::variables->{recordsppage};
      $data->{query} =~ s/id/\*/g;

         $sth = $dbh->prepare (qq{$string->{query} and work_status not like 'new' ORDER BY $data->{order_by} $data->{asc_desc} LIMIT $span_page, $CONFIG::variables->{recordsppage}});
         $sth->execute ();
      my $bi = 1;
         while (my @ary = $sth->fetchrow_array ()) {
            my $stmpformated = substr($ary[8],6,2) . "-" . substr($ary[8],4,2) . "-" . substr($ary[8],0,4) . " " . substr($ary[8],8,2) . ":" . substr($ary[8],10,2);
            if ($bi/2 == int ($bi/2) ) {$data->{bgcolor} = $CONFIG::variables->{listbgcolor1};}
            else {$data->{bgcolor} = $CONFIG::variables->{listbgcolor2};}
            $bi++;
            $ary[9] = $CONFIG::variables->{"ws_" . $ary[9]};
            $ary[10] = $CONFIG::variables->{"vs_" . $ary[10]};
            $ary[11] = $CONFIG::variables->{"rt_" . $ary[11]};
            $ary[12] = $CONFIG::variables->{"sc_" . $ary[12]};
            if (length($ary[5]) > 50) {$ary[5] = substr($ary[5], 0, 50) . "...";}
            $data->{search_results} .= qq~
                                        <tr>
                                        <td style="background:#$data->{bgcolor}" class=results>$ary[0]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>$ary[1]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$numlist->{$ary[2]}</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[3]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;<a href="new_messages.cgi?action=create&to=$ary[4]">$ary[4]</a></td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[5]</td>
                                        <td style="background:#$data->{bgcolor}" class=results><nobr>$stmpformated</nobr></td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[9]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[10]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[11]</td>
                                        <td style="background:#$data->{bgcolor}" class=results>&nbsp;$ary[12]</td>
                                        <td style="background:#$data->{bgcolor}" class=results><nobr><a href=old_messages.cgi?action=modify_form&id=$ary[0]>$CONFIG::variables->{'cmd_modify'}</a>
                                            &nbsp;<a href=old_messages.cgi?action=whole&id=$ary[1]>$CONFIG::variables->{'cmd_whole'}</a></nobr></td>
                                        </tr>~;
         }
         if ($data->{count} < 1) {$data->{search_results} = qq~<tr><td colspan=11>$CONFIG::variables->{'noresults'}</td></tr>~;}
         $sth->finish ();
         $dbh->disconnect ();
         &GLOBAL::template('oldmsg_results',$data,'navigation_old_messages');
   }
   elsif ($data->{action} eq "modify_form" && $data->{id}) {
      my $results = &GLOBAL::get_record($data->{id},$CONFIG::list_table);
         $results->{category_list} = &GLOBAL::get_cat;
      my $numlist = &GLOBAL::get_cat('numlist');
         $results->{category_translated} = $numlist->{$results->{category_id}};
         $results->{work_status} = qq~<option value=$results->{work_status}>~ . $CONFIG::variables->{"ws_" . $results->{work_status}} . qq~</option>~;
         $results->{view_status} = qq~<option value=$results->{view_status}>~ . $CONFIG::variables->{"vs_" . $results->{view_status}} . qq~</option>~;
         $results->{rating} = qq~<option value=$results->{rating}>~ . $CONFIG::variables->{"rt_" . $results->{rating}} . qq~</option>~;
         $results->{source} = qq~<option value=$results->{source}>~ . $CONFIG::variables->{"sc_" . $results->{source}} . qq~</option>~;
         if ($user->{access} eq "admin") {&GLOBAL::template('oldmsg_adminmodifyform',$results,'navigation_old_messages');}
         else {&GLOBAL::template('oldmsg_modifyform',$results,'navigation_old_messages');}
   }
   elsif ($data->{action} eq "modify" && $data->{id}) {
      my $results = &GLOBAL::get_record($data->{id},$CONFIG::list_table);
         $data->{tstmp} = &GLOBAL::datetime('tstmp');
           if ($user->{access} ne "admin") {
         my $results = &GLOBAL::get_record($data->{id},$CONFIG::list_table);
            $data->{owner} = $results->{owner};
            $data->{sender} = $results->{sender};
            $data->{work_status} = $results->{work_status};
            $data->{rating} = $results->{rating};
      }
      $data->{comment} = $results->{comment} . $data->{comment};
      &GLOBAL::modify_data($data,$CONFIG::list_table);
   my $numlist = &GLOBAL::get_cat('numlist');
      $data->{category_translated} = $numlist->{$data->{category_id}};
      $data->{content} =~ s/\n/<br>/g;
      $data->{work_status} = $CONFIG::variables->{"ws_" . $data->{work_status}};
      $data->{view_status} = $CONFIG::variables->{"vs_" . $data->{view_status}};
      $data->{rating} = $CONFIG::variables->{"rt_" . $data->{rating}};
      $data->{source} = $CONFIG::variables->{"sc_" . $data->{source}};
      &GLOBAL::template('oldmsg_modified',$data,'navigation_old_messages');
   }
   elsif ($data->{action} eq "create" && $data->{content} && $data->{subject}) {
         $data->{tstmp} = &GLOBAL::datetime('tstmp');
         $data->{rating} = "unrated";
         $data->{source} = "yes";
         $data->{work_status} = "noreply";
         $data->{owner} = $ENV{REMOTE_USER};
      my $record = &GLOBAL::add_data($data,$CONFIG::list_table);
         $data->{id} = $record->{used_id};
         $data->{ref_id} = $record->{used_id};
         $data->{content} =~ s/<[^>]*>//gs;
         &GLOBAL::modify_data($data,$CONFIG::list_table);
         open(DATA, ">>./data/$data->{id}.txt") || die &GLOBAL::error('nofile');
      my $mod = chmod 0774, "./data/$data->{id}.txt";
         print DATA qq~$data->{subject}\n\n$data->{content}~;
         close(DATA);
         $data->{work_status} = $CONFIG::variables->{"ws_" . $data->{work_status}};
         $data->{view_status} = $CONFIG::variables->{"vs_" . $data->{view_status}};
         $data->{rating} = $CONFIG::variables->{"rt_" . $data->{rating}};
         $data->{source} = $CONFIG::variables->{"sc_" . $data->{source}};
         &GLOBAL::template('oldmsg_created',$data,'navigation_old_messages');
   }
   elsif ($data->{action} eq "create_form") {
      $data->{category_list} = &GLOBAL::get_cat;
      &GLOBAL::template('oldmsg_createform',$data,'navigation_old_messages');
   }
   elsif ($data->{action} eq "whole" && $data->{id}) {
   my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
   my $sth = $dbh->prepare (qq{ SELECT * FROM $CONFIG::list_table WHERE ref_id like '$data->{id}' order by id} );
      $sth->execute ();
      $data->{count} = $sth->rows;
      while (my @ary = $sth->fetchrow_array ()) {
         my $stmpformated = substr($ary[8],6,2) . "-" . substr($ary[8],4,2) . "-" . substr($ary[8],0,4) . " " . substr($ary[8],8,2) . ":" . substr($ary[8],10,2);
         $ary[6] =~ s/\n/<br>/g;
         $ary[7] =~ s/\n/<br>/g;
         $data->{replies} .= qq~
            <tr><td style="background:#$CONFIG::variables->{listbgcolor2}"><nobr>$CONFIG::variables->{lf_id} / $CONFIG::variables->{lf_ref_id}</nobr>
                <td style="background:#$CONFIG::variables->{listbgcolor2}">$ary[0] / $ary[1]</td></tr>
            <tr><td valign=top>$CONFIG::variables->{lf_subject}<td>$ary[5]</td></tr>
            <tr><td>$CONFIG::variables->{lf_tstmp}</td><td>$stmpformated</td></tr>
            <tr><td valign=top>$CONFIG::variables->{lf_content}</td><td>$ary[6]</td></tr>
            <tr><td valign=top>$CONFIG::variables->{lf_comment}</td><td>$ary[7]</td></tr>
            ~;
      }
      if ($data->{count} < 1) {$data->{replies} = "<tr><td colspan=2>$CONFIG::variables->{'noresults'}</td></tr>";}
      $sth->finish ();
      $dbh->disconnect ();
      &GLOBAL::template('oldmsg_thread',$data,'navigation_old_messages');
   }
   else {
   use Calendar::Simple;
   my $today = ((localtime)[3]) . "-" . ((localtime)[4] + 1) . "-" . ((localtime)[5] + 1900);
   my $day = shift || (localtime)[3];
   my $mon = $in->param('month') || (localtime)[4] + 1;
   my $yr = $in->param('year') || ((localtime)[5] + 1900);
   my @month = calendar($mon, $yr);
   my $previous;
   my $next;
      if ($mon eq "1") {$previous->{month} = 12; $previous->{year} = $yr-1;}
      else {$previous->{month} = $mon-1; $previous->{year} = $yr;}
      if ($mon eq "12") {$next->{month} = 1; $next->{year} = $yr+1;}
      else {$next->{month} = $mon+1; $next->{year} = $yr;}
      $data->{calendar} = qq~
         <table border=0 cellspacing=1 cellpadding=2>
            <tr><td colspan=7 align=center>$today</td></tr>
            <tr><td><a href=old_messages.cgi?month=$previous->{month}&year=$previous->{year}>&lt;&lt;</a></td><td colspan=5 align=center>$CONFIG::month->{$mon} $yr</td><td><a href=old_messages.cgi?month=$next->{month}&year=$next->{year}>&gt;&gt;</a></td></tr>
            <tr><td>$CONFIG::day->{1}</td><td>$CONFIG::day->{2}</td><td>$CONFIG::day->{3}</td><td>$CONFIG::day->{4}</td><td>$CONFIG::day->{5}</td><td>$CONFIG::day->{6}</td><td>$CONFIG::day->{7}</td></tr>
      ~;
      foreach (@month) {
         if ($mon < 10 && length($mon) < 2) {$mon = "0$mon";}
         $data->{calendar} .= qq~<tr>~;
         foreach (@$_) {
            if ($_ < 10) {$day = "0$_";}
            else {$day = $_;}
            $data->{calendar} .= qq~<td align=right><a href="old_messages.cgi?action=search&tstmp=$yr$mon$day%">~;
            $data->{calendar} .= $_;
            $data->{calendar} .= qq~</a></td>~;
         }
         $data->{calendar} .= qq~</tr>~;
      }
   $data->{calendar} .= qq~</table>~;
      $data->{category_list} = &GLOBAL::get_cat;
   my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
   my $sth = $dbh->prepare (qq~SELECT userid FROM $CONFIG::staff_table ORDER BY userid~);
      $sth->execute ();
      while (my @ary = $sth->fetchrow_array ()) {$data->{owner_list} .= qq~<option>$ary[0]</option>~;}
         $sth->finish ();
         $dbh->disconnect ();
         &GLOBAL::template('oldmsg_searchform',$data,'navigation_old_messages');
   }
   exit;