#!/usr/bin/perl
####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: setup.cgi
#  Description: create tables
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################
$0 =~ /^(.*)[\/\\].*/ && chdir ($1) ; $|=1;
use strict;
use CGI();
use CGI::Carp('fatalsToBrowser');
use DBI;
use lib './admin/modules';
use GLOBAL;
use CONFIG;

my $in = new CGI;
   print $in->header();
   print qq~\n<pre>~;
my ($dbh,$sth,$htaccess);
my (@ary);
my $path = $ENV{PATH_TRANSLATED};
$path =~ s/setup.cgi//;
$path .= "admin";
open (DATA , "<$path/.htaccess") || die "Could not open .htaccess for reading. Make sure the file exists.";
while (<DATA>) {if ($_ =~ /$path\/.htpasswd/) {$htaccess = 1;}}
close(DATA);
if ($htaccess eq 1) {print qq~.htaccess path is set correctly\n~;}
else {
open(DATA, ">$path/.htaccess") ||
die "could not write .htaccess file to $path
If your account does not allow file writing please create a .htaccess with the following content:\n
AuthUserFile   $path/.htpasswd
AuthGroupFile  /dev/null
AuthType       Basic
AuthName       Protected
Options +ExecCGI -Includes
require valid-user";
print DATA
qq~AuthUserFile   $path/.htpasswd
AuthGroupFile  /dev/null
AuthType       Basic
AuthName       Protected
Options +ExecCGI -Includes
require valid-user\n~;
close(DATA);
}
$dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
print qq~\ndatabase connected~;
$dbh->do (qq~CREATE TABLE IF NOT EXISTS $CONFIG::default_table
(id int not null auto_increment,
subject varchar(100),
content text,
primary key (id))~);
print qq~\ndefault table created~;
$dbh->do (qq~CREATE TABLE IF NOT EXISTS $CONFIG::category_table
(id int not null auto_increment,
name varchar(255),
father int,
primary key (id))~);
print qq~\ncategory table created~;
$dbh->do (qq~CREATE TABLE IF NOT EXISTS $CONFIG::staff_table
(userid varchar(20) not null,
name varchar(100),
given varchar(100),
pass varchar(100),
access enum('regular','admin') default 'regular',
default_top text,
default_bottom text,
primary key (userid))~);
print qq~\nstaff table created~;
$dbh->do (qq~CREATE TABLE IF NOT EXISTS $CONFIG::list_table
(id int not null auto_increment,
ref_id int,
category_id int,
owner varchar(100) default 'service',
sender varchar(100),
subject varchar(255),
content text,
comment text,
tstmp timestamp,
work_status enum('new','reply_mail','reply_misc','noreply','sent') default 'new',
view_status enum('open','library','faq','junk') default 'open',
rating enum('top','medium','bad','again','unrated') default 'unrated',
source enum('yes','no') default 'yes',
primary key (id))~);
print qq~\nlist table created~;
$dbh->do (qq~INSERT $CONFIG::category_table (id,name,father) VALUES ('1','','0')~);
print qq~\nbasic category created~;
$dbh->do (qq~INSERT $CONFIG::staff_table (userid,pass,access) VALUES ('admin','master','admin')~);
print qq~\nadmin user creatd (username: admin password: master)~;
print qq~\nready to <a href=index.cgi>run</a> you should DELETE setup.cgi now! Your initial user/pass is admin/master</pre>~;
$dbh->disconnect ();
exit;